import model.AdminUser
import model.ManagerUser
import model.DefaultUser
import model.User
import java.time.LocalDate
import javax.crypto.SecretKeyFactory
import javax.crypto.spec.PBEKeySpec
import java.util.Base64


val authorizationList = mutableListOf<User>()


private const val HASH_LENGTH = 256
private const val ITERATIONS = 65536
val salt = "sosalt"


fun main() {
    while (true) {
        println("1) Регаться тут")
        println("2) Авторизироваться тут")
        var choice = readln()
        if (choice == "1") {
            authorizationList.add(registration())
            authorizationList.forEach{
                println(it.userId)
                println(it.login)
                println(it.password)
                println(it.email)
                println(it.lastAuthorizeDate)
            }
        }
        else {
            println(authorization())
        }
    }
}


fun hashPassword(password: String, salt: String): String {
    val saltBytes = Base64.getDecoder().decode(salt)
    val spec = PBEKeySpec(password.toCharArray(), saltBytes, ITERATIONS, HASH_LENGTH)
    val factory = SecretKeyFactory.getInstance("PBKDF2WithHmacSHA256")
    val hash = factory.generateSecret(spec).encoded
    return Base64.getEncoder().encodeToString(hash)
}


fun registration(): User{
    println("Почту пиши")
    val user_Email = readlnOrNull()
    checkNotNull(user_Email)
    require(user_Email.contains("@")) {
        "Добавь @"
    }

    println("Пароль пиши")
    val user_Password = readlnOrNull()
    checkNotNull(user_Password)
    require(user_Password.length >= 8 &&
            user_Password.any { it.isDigit() } &&
            user_Password.any { it.isLetter() && it in 'a'..'z' || it in 'A'..'Z' }
    ) {
        "Длинее делай или цифру/букву добавляй"
    }

    println("Заново пароль пиши")
    val user_Password1 = readlnOrNull()
    checkNotNull(user_Password1)
    require(user_Password1 == user_Password) {
        "Ну ты и тупорылый"
    }

    println("Логин пиши")
    val user_Login = readlnOrNull()
    checkNotNull(user_Login)
    require(user_Login.length >= 4) {
        "Длинее делай"
    }


    println("ТЫ КТО? 1) лох 2) админо 3) манагер")
    val role = readlnOrNull()
    checkNotNull(role)

    return when(role) {
        "1" -> return DefaultUser(
            userId = authorizationList.size + 1,
            login = user_Login,
            password = hashPassword(user_Password, salt),
            email = user_Email,
            lastAuthorizeDate = LocalDate.now()
        )

        "2" -> return AdminUser(
            userId = authorizationList.size + 1,
            login = user_Login,
            password = hashPassword(user_Password, salt),
            email = user_Email,
            lastAuthorizeDate = LocalDate.now()
        )

        "3" -> return ManagerUser(
            userId = authorizationList.size + 1,
            login = user_Login,
            password = hashPassword(user_Password, salt),
            email = user_Email,
            lastAuthorizeDate = LocalDate.now()
        )

        else -> { throw IllegalArgumentException("error") }
    }
}


fun authorization(): String{
    var adminFlg = true
    println("Почту пиши")
    val user_Email = readlnOrNull()
    checkNotNull(user_Email)
    val user = authorizationList.find { it.email == user_Email }
    require(user != null) {
        "нет такого"
    }

    println("Пароль пиши")
    val user_Password = readlnOrNull()
    checkNotNull(user_Password)
    require(user.password == hashPassword(user_Password, salt)) {
        "не то"
    }

    if (user is AdminUser) {
        while (adminFlg == true) {
            adminFlg = adminFunctional(user)
        }
    }

    return "такой есть"
}


fun adminFunctional(user: AdminUser): Boolean {
    println("1) Показать всех")
    println("2) Показать всех сорт")
    println("3) Поменять пароль")
    println("4) Удалить чела")
    println("5) Пока")

    var flg = readln()
    when(flg) {
        "1" -> user.allUsers(authorizationList)
        "2" -> user.allUsersSort(authorizationList)
        "3" -> user.updateUserPassword(authorizationList)
        "4" -> user.removeUser(authorizationList)
        "5" -> return false
    }

    return true
}

